//includes
var express = require('express');	
var fs = require('fs');
var rpio = require('rpio');
//initialisation du serveur web, des chemins locaux et du socket
var app = express();
app.engine('.html',require('ejs').__express);
app.set('views',__dirname + '/templates');
app.use('/jquery',express.static(__dirname + '/node_modules/jquery/dist/'));
app.use('/socketio',express.static(__dirname + '/node_modules/socket.io-client/dist/'));
app.use('/public',express.static(__dirname +  '/public/'));
var httpserver = require('http').createServer(app);
var socketio = require('socket.io').listen(httpserver);

// initialisation rpio et numéro des pin suivant GPIO
rpio.init({gpiomem: false});
rpio.init({mapping: 'gpio'});

//lecture des fichiers de config
var config = JSON.parse(fs.readFileSync('configDomoOpe.json'));

//setting rpio.spi
    var tx = new Buffer(3);
    var rx = new Buffer(3);
    rpio.spiBegin();
    rpio.spiChipSelect(0);
    rpio.spiSetCSPolarity(0, rpio.LOW);//cs enable at low
    rpio.spiSetClockDivider(64);// speed spi 6.25 mhz on pi3
    rpio.spiSetDataMode(0);//spi mode 0
    
    //setting mcp23s17 IOs
    //validation haen pour prise en compte adresses physiques
    tx = Buffer([0x40,0x0A,0x08]);//0100000w,IOCON,positionne HAEN
    rpio.spiTransfer(tx, rx, 3);
    //init port A adresse 000 all output commandes volets 0 à 3
    tx = Buffer([0x40,0x00,0x00]);//0100000W,IODIRA,all output
    rpio.spiTransfer(tx, rx, 3);
    //init port A adresse 001 all output commandes volet 8
    tx = Buffer([0x42,0x00,0x00]);//0100001w,IODIRA,all output
    rpio.spiTransfer(tx, rx, 3);
    //init port B adresse 000 all output commandes volets 4 à 7
    tx = Buffer([0x40,0x01,0x00]);//0100000w,IODIRB,all output
    rpio.spiTransfer(tx, rx, 3);
    //init port B adresse 001 all output commandes stores
    tx = Buffer([0x42,0x01,0x00]);//0100001w,IODIRB,all output
    rpio.spiTransfer(tx, rx, 3);
    //init port A adresse 010 all input, all Pull-up boutons poussoirs volets 0 à7
    tx = Buffer ([0x44,0x00,0xFF]);//0100010W,IODIRA,all input
    rpio.spiTransfer(tx, rx, 3);
    tx = Buffer([0x44,0x0C,0xFF]);//0100010W,GPPUA,all pull-up
    rpio.spiTransfer(tx, rx, 3);
    //init port B adresse 010 all intput, all pull-up bouton poussoir volets 8
    tx = Buffer([0x44,0x01,0xFF]);//0100010W,IODIRB,all input
    rpio.spiTransfer(tx, rx, 3);
    tx = Buffer([0x44,0x0D,0xFF]);
    rpio.spiTransfer(tx, rx, 3);//0100010W,GPPUB, all pull-up
    //init port A adresse 011 all input, all Pull-up
    //tx = Buffer([0x46,0x00,0xFF]);//0100011W,IODIRA,all input
    //rpio.spiTransfer(tx, rx, 3);
    //tx = Buffer([0x46,0x0C,0xFF]);
    //rpio.spiTransfer(tx, rx, 3);//0100011W,GPPUA, all pull-up
    //init port B adresse 0011 all input, all pull-up
    //tx = Buffer([0x46,0x01,0xFF]);//0100011W,IODIRB,all input
    //rpio.spiTransfer(tx, rx, 3);
    //tx = Buffer([0x46,0x0D,0xFF]);
    //rpio.spiTransfer(tx, rx, 3);//0100011W,GPPUB, all pull-up

    rpio.spiEnd();//close spi

			
//Route de distribution de la page web par defaut
app.get('/',function(req,res){
	res.render('indexDomoOpe.html');
});

//Route qui retourner les paramètres et leurs état 
//au format Json (pas utile ici, mais c'est cadeau)
//app.get('/perif',function(req,res){
//		res.json(config.perif);
//});

//socketio à ecoute
socketio.sockets.on('connection',function(client){
	 
	 //fourni la configuration au client qui se connecte
	 client.emit('connected',{config : config}); 	 
	 
	 //recoit une demande de changement du client	
	 client.on('perifchange',function(data)
	 {	 
		 //appel de changement d'etat de l'output
		 changeVolets(data.iden);		 		 
	 });
});

function readSpi(opcoder,registre,données)
    {
     //setting rpio.spi
    var tx = new Buffer(3);
    var rx = new Buffer(3);
    rpio.spiBegin();
    rpio.spiChipSelect(0);
    rpio.spiSetCSPolarity(0, rpio.LOW);//cs enable at low
    rpio.spiSetClockDivider(64);// speed spi 6.25 mhz on pi3
    rpio.spiSetDataMode(0);//spi mode 0
    //lire port?? adresse ??? toutes sorties à données
    tx = Buffer([opcoder,registre,données]);
    rpio.spiTransfer(tx, rx, 3);
    rpio.spiEnd();
    readport = ((rx[2]).toString(16)).toUpperCase();
    return readport;
    }

function lectureBp()
{
readSpi(0x45,0x12,0x00);//pour le port gpio a
var sortieporta = readport;
if (sortieporta != oldsortieporta)
    {
//      if ( sortieporta == "FE" ){ changeVolets(0);}
//        else { if (sortieporta == "FD"){ changeVolets(1);}
//           else { if (sortieporta == "FB"){ changeVolets(2);}
//                else { if (sortieporta == "F7"){ changeVolets(3);}
//                      else { if (sortieporta == "EF"){ changeVolets(4);}
//                            else { if (sortieporta == "DF"){ changeVolets(5);}
//                                  else { if (sortieporta == "BF"){ changeVolets(6);}
//                                        else { if (sortieporta == "7F"){ changeVolets(7);}
//                                           }
//                                     }
//                               }
//                         }
//                    }
//             }
//      }
//    }
    var oldsortieporta = readport;
    }    
readSpi(0x45,0x13,0x00);// pour le port gpio b
var sortieportb = readport;
if (sortieportb != oldsortieportb)
    {
        if ( sortieportb == "FE" ){ changeVolets(8);}
//        else { if (sortieportb == "FD"){ console.log("en attente ");}
//            else { if (sortieportb == "FB"){ console.log("en attente ");}
//                else { if (sortieportb == "F7"){ console.log("en attente ");}
//                      else { if (sortieportb == "EF"){ console.log("en attente ");}
//                            else { if (sortieportb == "DF"){ console.log("en attente ");}
//                                  else { if (sortieportb == "BF"){ console.log("en attente ");}
//                                        else { if (sortieportb == "7F"){ console.log("en attente ");}
//                                             }
//                                       }
//                                 }
//                           }
//                     }
//               }
//             }
    var oldsortieportb = readport;
    }

}
setInterval(lectureBp, 300);
sp0 = 10;
sp1 = 11;
sp2 = 12;

function changeVolets(i)
{//début1
var t = config.perifVolets[i].taux;
var e = config.perifVolets[i].etat;
var p = config.perifVolets[i].position;
var dep = config.perifVolets[i].dep;
var s = config.perifVolets[i].sens;
var temp = config.perifVolets[i].tempo;
var auto = config.perifVolets[config.credit.nbrvolets].auto;

    function trisortieport(i,param1,param2,param3)
    {  //mise à jour de la sortie du port mcp en fonction du volet
        //début2
        if ( Math.trunc(i/4) === 0)//pour le port A du premier mcp
        {//début3
            if ( param3 === 0 )
            {   //mise à zéro de deux bits sortieport sans changer les autres
            sp0 = config.credit.sortieport0;
            sp0 = ( (sp0) & (param1)) & (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp0);
            config.credit.sortieport0 = sp0;
            }
            else if ( param3 === 1 )
            {       //mise à zero-un de deux bits de sortieport
            sp0 = config.credit.sortieport0;
            sp0 = ((sp0) | (param1) ) & (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp0);
            config.credit.sortieport0 = sp0;
            console.log("point 2 sp0 = "+sp0);
            }
            else if ( param3 === 2 )
            {   //mise à un-zero de deux bits de sortieport
            sp0 = config.credit.sortieport0;
            sp0 = ((sp0) & (param1)) | (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp0);
            config.credit.sortieport0 = sp0;
            console.log("point 3 sp = "+sp0);
            }
        return sp0;
        }//fin3
     else if   ( Math.trunc(i/4) === 1)//pour le port B du premier mcp
        {//début4
            if ( param3 === 0 )
            {   //mise à zéro de deux bits sortieport sans changer les autres
            sp1 = config.credit.sortieport1;
            sp1 = ( (sp1) & (param1)) & (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp1);
            config.credit.sortieport1 = sp1;
            }
            else if ( param3 === 1 )
            {       //mise à zero-un de deux bits de sortieport
            sp1 = config.credit.sortieport1;
            sp1 = ((sp1) | (param1) ) & (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp1);
            config.credit.sortieport1 = sp1;
            }
            else if ( param3 === 2 )
            {   //mise à un-zero de deux bits de sortieport
            sp1 = config.credit.sortieport1;
            sp1 = ((sp1) & (param1)) | (param2);
            ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp1);
            config.credit.sortieport1 = sp1;
            }
            return sp1;  
        }//fin4 
            else if ( Math.trunc(i/4) === 2) //pour le port A du deuxième mcp
        {//début5
             if ( param3 === 0 )
             {   //mise à zéro de deux bits sortieport sans changer les autres
             sp2 = config.credit.sortieport2;
             sp2 = ( (sp2) & (param1) ) & (param2);
             ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp2);
             config.credit.sortieport2 = sp2;
             }
             else if ( param3 === 1 )
             {       //mise à zero-un de deux bits de sortieport
             sp2 = config.credit.sortieport2;
             sp2 = ((sp2) | (param1) ) & (param2);
             ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp2);
             config.credit.sortieport2 = sp2;
             }
             else if ( param3 === 2 )
             {   //mise à un-zero de deux bits de sortieport
             sp2 = config.credit.sortieport2;
             sp2 = ((sp2) & (param1) | (param2));
             ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sp2);
             config.credit.sortieport2 = sp2;
             }
             return sp2;
        }//fin5
    }//fin2

    function ecritureSpi(opcodew,registre,données)
    {//début6
     //setting rpio.spi
    var tx = new Buffer(3);
    var rx = new Buffer(3);
    rpio.spiBegin();
    rpio.spiChipSelect(0);
    rpio.spiSetCSPolarity(0, rpio.LOW);//cs enable at low
    rpio.spiSetClockDivider(64);// speed spi 6.25 mhz on pi3
    rpio.spiSetDataMode(0);//spi mode 0
    //ecrire portA adresse ??? toutes sorties à données
    console.log("opcodew = "+opcodew+" registre = "+registre+" données = "+données);
    tx = Buffer([opcodew,registre,données]);
    rpio.spiTransfer(tx, rx, 3);
    rpio.spiEnd();
    }//fin6

    function gestionStores()
        {
            temp = config.perifVolets[i].tempo;
            dep = config.perifVolets[i].dep;
            p = config.perifVolets[i].position;
            p++;
            config.perifVolets[i].position = p;
            if ( dep == 55 ) //pas d'action en cours
            {
                config.perifVolets[i].dep = 33;
                sortieport = config.perifVolets[i].port;
                sortieport = (sortieport |(config.perifVolets[i].masquex1));
                ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sortieport);
                config.perifVolets[i].port = sortieport;
            }
            else if ( p > temp ) // action en cours
            {
                sortieport = config.perifVolets[i].port;
                sortieport = (sortieport & (config.perifVolets[i].masquex0));
                ecritureSpi(config.perifVolets[i].opcodew,config.perifVolets[i].registre,sortieport);    
                config.perifVolets[i].port = sortieport;
                p = 1;
                config.perifVolets[i].position = p;
                config.perifVolets[i].dep = 55;
                clearInterval(x);
            }

        }
    
	function fermeture()
		{//début7
			//calcul du taux de progression
			temp = config.perifVolets[i].tempo;
			t = Math.trunc((p/temp)*100);
			dep = config.perifVolets[i].dep;
			p ++;
			//met a jour la property etat et taux du perif
			config.perifVolets[i].etat = e;
			config.perifVolets[i].taux = t;
			config.perifVolets[i].position = p;
			//broadcast le status du perif à tous les clients
			var data = {'etat' : e,'iden' : i,'taux' : t};
			socketio.sockets.emit('perifchange',data);
			if ((p > temp) || (dep == 55))
			{
				clearInterval(x);
				if (dep == 55)
				{
					e = 3;
					config.perifVolets[i].etat = e;
					data = {'etat' : e,'iden' : i,'taux' : t};
					socketio.sockets.emit('perifchange',data);
                    trisortieport(i,config.perifVolets[i].masque0x,config.perifVolets[i].masquex0,0);           
				}
				if (p > temp)
                {
					e = 4;
					p = temp;
					dep = 55;
					config.perifVolets[i].etat = e;
					config.perifVolets[i].position = p;
					config.perifVolets[i].dep = dep;
					data = {'etat' : e,'iden' : i,'taux' : t};
                    socketio.sockets.emit('perifchange',data);
                    trisortieport(i,config.perifVolets[i].masque0x,config.perifVolets[i].masquex0,0);
				}
			}
        }//fin7
	function ouverture()
		{//début8
			//calcul du taux de progression
			temp = config.perifVolets[i].tempo;
			t = Math.trunc(((temp - p)/temp)*100);
			dep = config.perifVolets[i].dep;
			p --;
			//met à jour les property etat et taux du perif
			config.perifVolets[i].etat = e;
			config.perifVolets[i].taux = t;
			config.perifVolets[i].position = p;
			//broadsast le status du perif à tous les clients
			var data = {'etat' : e,'iden' : i,'taux' : t};
			socketio.sockets.emit('perifchange',data);
			if ((p < 1) || (dep == 55))
			{
				clearInterval(x);
				if (dep == 55){
					e = 5;
					config.perifVolets[i].etat = e;
					data = {'etat' : e,'iden' : i,'taux' : t};
					socketio.sockets.emit('perifchange',data);
                    trisortieport(i,config.perifVolets[i].masque0x,config.perifVolets[i].masquex0,0);
				}
				if (p < 1)
                {
					e = 1;
					p = 1;
					dep = 55;
					t = 0;
					config.perifVolets[i].dep = dep;
					config.perifVolets[i].etat = e;
					config.perifVolets[i].position = p;
					config.perifVolets[i].taux = t;
					data = {'etat' : e,'iden' : i,'taux' : t};
					socketio.sockets.emit('perifchange',data);
                    trisortieport(i,config.perifVolets[i].masque0x,config.perifVolets[i].masquex0,0);
				}
			}
		}//fin8  

if ( i < 10) // partie volets électriques

    {//début9

	if (dep == 55) // volet à l'arrêt
		{//début10	
		if (p == 1) //volet ouvert donc en haut
			{
			dep = 33;
			e = 2;
			s = "descente";
			config.perifVolets[i].sens = s;
			config.perifVolets[i].dep = dep;
			config.perifVolets[i].etat = e;
			data = {'etat' : e,'iden' : i,'taux' : t};
			socketio.sockets.emit('perifchange',data);
			var compteur =1;
            trisortieport(i,config.perifVolets[i].masquex0,config.perifVolets[i].masque1x,2);

			var x = setInterval(fermeture,500);
			
			}
			else if(p == temp)//volet fermé donc en bas
				{
				dep = 33;
				e = 6;
				t = 0;
				s = "montee";
				config.perifVolets[i].dep = dep;
				config.perifVolets[i].etat = e;
				config.perifVolets[i].taux = t;
				config.perifVolets[i].sens = s;
				data = {'etat' : e,'iden' : i,'taux' :t};
				socketio.sockets.emit('perifchange',data);
				var compteur =50;
                trisortieport(i,config.perifVolets[i].masquex1,config.perifVolets[i].masque0x,1);
                
                var x = setInterval(ouverture,500);
				}
				else if(s == "montee")//volet arrêté en position intermédiaire montée
					{
					dep = 33;
					e = 2;
					s = "descente";
					config.perifVolets[i].dep = dep;
					config.perifVolets[i].etat = e;
					config.perifVolets[i].sens = s;
					data = {'etat' : e,'iden' : i,'taux' : t};
					socketio.sockets.emit('perifchange',data);
					var compteur = p;
                    trisortieport(i,config.perifVolets[i].masquex0,config.perifVolets[i].masque1x,2);
                    
                    var x = setInterval(fermeture, 500);
					}
					else
                    {
						dep = 33;
						e = 6;
						s = "montee";
						config.perifVolets[i].dep = dep;
						config.perifVolets[i].etat = e;
						config.perifVolets[i].sens = s;
						data = {'etat' : e,'iden' : i,'taux' : t};
						socketio.sockets.emit('perifchange',data);
						var compteur = p;
                        trisortieport(i,config.perifVolets[i].masquex1,config.perifVolets[i].masque0x,1);
                        
                        var x = setInterval(ouverture, 500);
					}
		}//fin10
	else if(dep == 33)//volet en mouvement
		{//début11
			dep = 55;
			config.perifVolets[i].dep = dep;
            trisortieport(i,config.perifVolets[i].masque0x,config.perifVolets[i].masquex0,0);

        }//fin11
    
    if(dep == 99) // appui sur bouton automatique
        {//début12
         if (auto == 1)  //passage de automatique à manuel
            {
                auto = 0;
                flagauto = 0;
                config.perifVolets[config.credit.nbrvolets].auto = auto;
                e = 7;
                config.perifVolets[i].etat = e;
                var data = { 'auto' : auto, 'etat' : e, 'iden' : i};
                socketio.sockets.emit('perifchange',data);
            }
            else  // passage de manuel à automatique
            {
                auto = 1;
                flagauto = 1;
                config.perifVolets[config.credit.nbrvolets].auto = auto;
                e = 7;
                config.perifVolets[i].etat = e;
                var data = { 'auto' : auto, 'etat' : e, 'iden' : i};
                socketio.sockets.emit('perifchange',data);      
            }
        }//fin12
    }//fin9

else //partie stores
        //la sécurité est assurée par les commandes somfy

        var x = setInterval(gestionStores,50);

	//monitoring dans la console pour faire joli
	console.log(new Date().toLocaleString() + ' : ' + config.perifVolets[i].name + ' is set to ' + e + " taux = " + config.perifVolets[i].taux);
}//fin1

function automatique()
    {
        auto = config.perifVolets[config.perifVolets.length - 1].auto;
            if (auto == 1)
            {  
                var dd = new Date().toLocaleString();
                var mmin = 99;
                var hmin = 99;
                for (var i = 0; i< dd.length; i++)
                    {
                        if (dd[i] == "-")
                        {
                            if (mmin == 99)
                            {var mmin = i;}
                            else
                            { var mmax = i;}
                        }
                    else if (dd[i] == ":")
                        {
                            if (hmin == 99)
                            {hmin = i;}
                            else
                            {var hmax = i;}
                        }
                    }
                var hh = dd.substring((mmax+3),hmin);
                var mm = parseInt(dd.substring((mmin+1),mmax));
                var hmatin = 8;
                var hsoir = 99;
                switch(mm){
                    case 0 :
                        hsoir = 19;
                        break;
                    case 1 :
                        hsoir = 19;
                        break;
                    case 2 :
                        hsoir = 20;
                        break;
                    case 3 :
                        hsoir = 20;
                        break;
                    case 4 :
                        hsoir = 20;
                        break;
                    case 5 :
                        hsoir = 21;
                        break;
                    case 6 :
                        hsoir = 21;
                        break;
                    case 7 :
                        hsoir = 22;
                        break;
                    case 8 :
                        hsoir = 22;
                        break;
                    case 9 :
                        hsoir = 21;
                        break;
                    case 10 :
                        hsoir = 20;
                        break;
                    case 11 :
                        hsoir = 20;
                        break;
                    case 12 :
                        hsoir = 19;
                        break;
                    default :
                        hsoir = 20;
                }
                function pair(chiffre)
                    {
                        chiffre = parseInt(chiffre);
                        return ((chiffre && 1)=='0')?true:false;
                    }

                if ( hh == hmatin)
                    {
                    for (var j = 0;j<config.perifVolets.length - 1; j++)
                    {
                        if ( config.perifVolets[j].taux !== 0)
                            {
                                if ( config.perifVolets[j].dep == 55)
                                {
                                    changeVolets(j);
                                    j = config.perifVolets.length;
                                }
                            }
                    }
                    }
                if ( hh == hsoir)
                    {
                    for (var j = 0;j<config.perifVolets.length - 1; j++)
                    {                    
                        if ( config.perifVolets[j].taux !== 100)
                            {
                                if ( config.perifVolets[j].dep == 55 )
                                {
                                    changeVolets(j);
                                    j = config.perifVolets.length;
                                }
                            }
                            
                    }
                    }
            }    
    }

 setInterval(automatique, 60000);



//demarre le serveur web
httpserver.listen(8080);

console.log ('CTRL+C pour quitter');


